
/*
DIAGRAMME DE RAYONNEMENT D'ANTENNE.
----------------------------------
Dans le Setup modifier la valeur "Tempo" 
de façon à calibrer le programme selon la vitesse de
rotation du rotor utilisé. (ici environ 2')

 Appro Sonde: https://www.sv1afn.com/adl5513.html 
  
 Mon site  http://f5mna.free.fr

Aout 2014.
*/

#include <U8glib.h> 
#include <Wire.h>
#include <Math.h>

U8GLIB_ST7920_128X64_1X u8g(6, 5, 4 ,7);     // Pour ST7920 128*64 sans platine additive

int  Anglediag, xdiag, ydiag,x,Mini,Maxi,NbrePts,Attenu,Tempo,n;
float rad , Angle;
int Buffer[400];              // Mémorisation des valeurs (360 --> 600) pour modif éventuelle
const int Relais = 13;        // Commande M/A relais rotor
boolean Marche = false;    
int PotAttenu = 1;            // Potentiomètre réglage niveau 

const int buttonPin = 2;      // Bouton M/A connecté Pin D2
                              // Résistance de tirage 4.7K au + 5V
int buttonPushCounter = 0;    // variable pour le comptage du nombre d'appuis sur le bouton poussoir
int buttonState = 1;          //Variable pour l'état actuel du bouton poussoir
int lastButtonState = 1;      // Variable pour l'état précédent du bouton poussoir


void setup( ) 
{
  Serial.begin (9600);        // Init RS232
  rad = 0.01745; //rad = ((2 * 3.1415926536) / 360);
   /////////////////////////////////////////////////////////////////////////////
  Tempo = 327;   //  millis secondes. Valeur tempo à ajuster selon rotor utilisé 
  /////////////////////////////////////////////////////////////////////////////
  NbrePts = 360; //  Nombre de points pour une rotation de 360° 
  Angle = 1;     //  360/NbrePts.  Modif si le nombre de points change 
  n=1;
  pinMode(Relais, OUTPUT); //Relais pour rotor
  boolean Marche = false; 
  digitalWrite(Relais, HIGH);
  for (int x=0; x <=NbrePts; x++) //Remplissage du Buffer au démarrage.
   {
    Buffer[x] = 1;
   } 
 } 

void Diagram() {  
   
  //Présentation digramme
   u8g.setFont(u8g_font_5x7);
   u8g.drawStr( 71, 7,  "DIAGRAMME");
   u8g.drawStr( 71, 14, " ANTENNE");
    //dessin du cercle
   u8g.drawLine(0,32,64,32); //Ordonnee  
   u8g.drawLine(31,0,31,64); //Abscisse 
   u8g.drawLine(32,30,40,2); //-15° 
   u8g.drawLine(30,30,22,2); //+15° 
   u8g.drawCircle(31,32,8); //-30 dB
   u8g.drawCircle(31,32,15); //-20 dB
   u8g.drawCircle(31,32,22); //-10 dB
   u8g.drawCircle(31,32,30); // 0 dB         
 
  // Bouton Marche/arret d'urgence
   buttonState = digitalRead(buttonPin);
  // compare l'état actuel du bouton poussoir à l'état précédent mémorisé
  if (buttonState != lastButtonState)
   {
     if (buttonState == LOW)  buttonPushCounter++;
     lastButtonState = buttonState;
   }
  if (buttonPushCounter % 2 == 0)  // si le reste de variable/2 vaut 0
  {
   Marche = false;            // Arret
   digitalWrite(Relais, HIGH);   
   u8g.setFont(u8g_font_micro);
   u8g.drawStr(84,63, "STOP");   
   }
  else {                     // Marche
   Marche = true;
   digitalWrite(Relais, LOW);   
  } 
     //Arrêt auto
       if (x == NbrePts) 
       { 
         if (n == 1) (Serial.println ("Stop"));
         n = 2;
         Marche = false;
         digitalWrite(Relais, HIGH);  
         u8g.setFont(u8g_font_micro);
         u8g.drawStr(84,63, "STOP");
       } 
  /////////////////////////////////////
   if (Marche == true) 
  { 
   //acquisition    
   if  (x <= NbrePts) ( x = x++ ); // Rotation    
   delay (Tempo);                  // Valeur modifiée selon rotor (Setup)
   
   u8g.drawStr(67,26, "Acquisition"); //Info "Marche"
   u8g.drawStr(67,36, " en cours"); 
   
   //Potentiometre d'attenuation.
   //Translation 0.8 volts sur la droite "tension/dBm"
    Attenu = analogRead (PotAttenu);   // Calibration
    Attenu = map(Attenu,0,1023,0,163); // On retranche de 0 à 0.8 Volts: 40 dB.
    Buffer[x] = ((analogRead(A0)+48))-Attenu; // De façon à ce que la sensibiité minimum soit le 0.     
    if (x <= NbrePts) (Serial.println (Buffer[x]+200)); //Affichage données via RS232
   //Données corrigées +200 de façon à ce que le RS232 expédie toujours 3 chiffres à chaque mesure
   //sinon le temps de rotation serait modifié. Le tableur fera la correction.  
   
   //Mise à l'échelle pour l'afficheur LCD     
   Buffer[x] = Buffer[x] * 0.182;  // Mini = 0, Maxi = 163 * 0.182 = int 30 (variation de 0.8 Volts  40dB). 
   }  
   if (Marche == false)    
  { 
   for (int x= 0; x <= NbrePts; x++)
       { 
   Anglediag = (Angle * x)-90; //Angle selon valeur du nbre de points/tour 
   xdiag = 31 + (cos(Anglediag * rad)*Buffer[x]);
   ydiag = 32 + (sin(Anglediag * rad)*Buffer[x]);
   u8g.drawLine(31, 32, xdiag, ydiag);   
       }   
   //Info calibrage 0 dB au lancement de la mesure.
   if ((Buffer[x] > 28) && (Buffer[x] < 32)) (u8g.drawStr( 3, 7, "OK"));
  
   //Rapport avant/arrière
   if (x > NbrePts/2)
   {
   Maxi = Buffer[1] ;
   Mini = Buffer[NbrePts/2]; // Sur 180°;
       if (Mini<Maxi)
       {
   u8g.setFont(u8g_font_micro);  
   u8g.drawStr( 67, 30, "Rapport AV/AR");  
   float AV_AR = ((float)((Maxi-Mini)* 1.33)) ; //Passage float/string
   char dB[2];
   dtostrf(AV_AR,2,0,dB);
   u8g.drawStr(82,37,dB);
   u8g.drawStr(94,37, "dB");    
   }  } 
  }
  }
    void loop() 
  {   
   u8g.firstPage();  
   do 
   Diagram(); 
   while( u8g.nextPage()); 
  }
